Module javafx.graphics
Package javafx.scene.shape

# Class CubicCurve

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape
javafx.scene.shape.CubicCurve

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class CubicCurve extends Shape

The `CubiCurve` class defines a cubic Bézier parametric curve segment in (x,y) coordinate space. Drawing a curve that intersects both the specified coordinates `(startX, startY)` and `(endX, enfY)`, using the specified points `(controlX1, controlY1)` and `(controlX2, controlY2)` as Bézier control points. Example:

    import javafx.scene.shape.*;

    CubicCurve cubic = new CubicCurve();
    cubic.setStartX(0.0f);
    cubic.setStartY(50.0f);
    cubic.setControlX1(25.0f);
    cubic.setControlY1(0.0f);
    cubic.setControlX2(75.0f);
    cubic.setControlY2(100.0f);
    cubic.setEndX(100.0f);
    cubic.setEndY(50.0f);
    }

Since:
  JavaFX 2.0

## Property Summary

Properties
Type
Property
Description
`final DoubleProperty`
`controlX1`
Defines the X coordinate of the first control point of the cubic curve segment.
`final DoubleProperty`
`controlX2`
Defines the X coordinate of the second control point of the cubic curve segment.
`final DoubleProperty`
`controlY1`
Defines the Y coordinate of the first control point of the cubic curve segment.
`final DoubleProperty`
`controlY2`
Defines the Y coordinate of the second control point of the cubic curve segment.
`final DoubleProperty`
`endX`
Defines the X coordinate of the end point of the cubic curve segment.
`final DoubleProperty`
`endY`
Defines the Y coordinate of the end point of the cubic curve segment.
`final DoubleProperty`
`startX`
Defines the X coordinate of the start point of the cubic curve segment.
`final DoubleProperty`
`startY`
Defines the Y coordinate of the start point of the cubic curve segment.

### Properties inherited from class javafx.scene.shape.Shape

`fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`CubicCurve()`
Creates an empty instance of CubicCurve.
`CubicCurve(double startX, double startY, double controlX1, double controlY1, double controlX2, double controlY2, double endX, double endY)`
Creates a new instance of CubicCurve.

## Method Summary

Modifier and Type
Method
Description
`final DoubleProperty`
`controlX1Property()`
Defines the X coordinate of the first control point of the cubic curve segment.
`final DoubleProperty`
`controlX2Property()`
Defines the X coordinate of the second control point of the cubic curve segment.
`final DoubleProperty`
`controlY1Property()`
Defines the Y coordinate of the first control point of the cubic curve segment.
`final DoubleProperty`
`controlY2Property()`
Defines the Y coordinate of the second control point of the cubic curve segment.
`final DoubleProperty`
`endXProperty()`
Defines the X coordinate of the end point of the cubic curve segment.
`final DoubleProperty`
`endYProperty()`
Defines the Y coordinate of the end point of the cubic curve segment.
`final double`
`getControlX1()`
Gets the value of the `controlX1` property.
`final double`
`getControlX2()`
Gets the value of the `controlX2` property.
`final double`
`getControlY1()`
Gets the value of the `controlY1` property.
`final double`
`getControlY2()`
Gets the value of the `controlY2` property.
`final double`
`getEndX()`
Gets the value of the `endX` property.
`final double`
`getEndY()`
Gets the value of the `endY` property.
`final double`
`getStartX()`
Gets the value of the `startX` property.
`final double`
`getStartY()`
Gets the value of the `startY` property.
`final void`
`setControlX1(double value)`
Sets the value of the `controlX1` property.
`final void`
`setControlX2(double value)`
Sets the value of the `controlX2` property.
`final void`
`setControlY1(double value)`
Sets the value of the `controlY1` property.
`final void`
`setControlY2(double value)`
Sets the value of the `controlY2` property.
`final void`
`setEndX(double value)`
Sets the value of the `endX` property.
`final void`
`setEndY(double value)`
Sets the value of the `endY` property.
`final void`
`setStartX(double value)`
Sets the value of the `startX` property.
`final void`
`setStartY(double value)`
Sets the value of the `startY` property.
`final DoubleProperty`
`startXProperty()`
Defines the X coordinate of the start point of the cubic curve segment.
`final DoubleProperty`
`startYProperty()`
Defines the Y coordinate of the start point of the cubic curve segment.
`String`
`toString()`
Returns a string representation of this `CubicCurve` object.

### Methods inherited from class javafx.scene.shape.Shape

`fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### startX

public final DoubleProperty startXProperty
Defines the X coordinate of the start point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getStartX()`
  - `setStartX(double)`
  - `startXProperty()`

### startY

public final DoubleProperty startYProperty
Defines the Y coordinate of the start point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getStartY()`
  - `setStartY(double)`
  - `startYProperty()`

### controlX1

public final DoubleProperty controlX1Property
Defines the X coordinate of the first control point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getControlX1()`
  - `setControlX1(double)`
  - `controlX1Property()`

### controlY1

public final DoubleProperty controlY1Property
Defines the Y coordinate of the first control point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getControlY1()`
  - `setControlY1(double)`
  - `controlY1Property()`

### controlX2

public final DoubleProperty controlX2Property
Defines the X coordinate of the second control point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getControlX2()`
  - `setControlX2(double)`
  - `controlX2Property()`

### controlY2

public final DoubleProperty controlY2Property
Defines the Y coordinate of the second control point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getControlY2()`
  - `setControlY2(double)`
  - `controlY2Property()`

### endX

public final DoubleProperty endXProperty
Defines the X coordinate of the end point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getEndX()`
  - `setEndX(double)`
  - `endXProperty()`

### endY

public final DoubleProperty endYProperty
Defines the Y coordinate of the end point of the cubic curve segment.

Default value:
  0.0
See Also:
  - `getEndY()`
  - `setEndY(double)`
  - `endYProperty()`

## Constructor Details

### CubicCurve

public CubicCurve()
Creates an empty instance of CubicCurve.

### CubicCurve

public CubicCurve(double startX, double startY, double controlX1, double controlY1, double controlX2, double controlY2, double endX, double endY)
Creates a new instance of CubicCurve.

Parameters:
  `startX` - the X coordinate of the start point
  `startY` - the Y coordinate of the start point
  `controlX1` - the X coordinate of the first control point
  `controlY1` - the Y coordinate of the first control point
  `controlX2` - the X coordinate of the second control point
  `controlY2` - the Y coordinate of the second control point
  `endX` - the X coordinate of the end point
  `endY` - the Y coordinate of the end point
Since:
  JavaFX 2.1

## Method Details

### setStartX

public final void setStartX(double value)
Sets the value of the `startX` property.

Property description:
  Defines the X coordinate of the start point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `startX` property
See Also:
  - `getStartX()`
  - `startXProperty()`

### getStartX

public final double getStartX()
Gets the value of the `startX` property.

Property description:
  Defines the X coordinate of the start point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `startX` property
See Also:
  - `setStartX(double)`
  - `startXProperty()`

### startXProperty

public final DoubleProperty startXProperty()
Defines the X coordinate of the start point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `startX` property
See Also:
  - `getStartX()`
  - `setStartX(double)`

### setStartY

public final void setStartY(double value)
Sets the value of the `startY` property.

Property description:
  Defines the Y coordinate of the start point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `startY` property
See Also:
  - `getStartY()`
  - `startYProperty()`

### getStartY

public final double getStartY()
Gets the value of the `startY` property.

Property description:
  Defines the Y coordinate of the start point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `startY` property
See Also:
  - `setStartY(double)`
  - `startYProperty()`

### startYProperty

public final DoubleProperty startYProperty()
Defines the Y coordinate of the start point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `startY` property
See Also:
  - `getStartY()`
  - `setStartY(double)`

### setControlX1

public final void setControlX1(double value)
Sets the value of the `controlX1` property.

Property description:
  Defines the X coordinate of the first control point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `controlX1` property
See Also:
  - `getControlX1()`
  - `controlX1Property()`

### getControlX1

public final double getControlX1()
Gets the value of the `controlX1` property.

Property description:
  Defines the X coordinate of the first control point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `controlX1` property
See Also:
  - `setControlX1(double)`
  - `controlX1Property()`

### controlX1Property

public final DoubleProperty controlX1Property()
Defines the X coordinate of the first control point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `controlX1` property
See Also:
  - `getControlX1()`
  - `setControlX1(double)`

### setControlY1

public final void setControlY1(double value)
Sets the value of the `controlY1` property.

Property description:
  Defines the Y coordinate of the first control point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `controlY1` property
See Also:
  - `getControlY1()`
  - `controlY1Property()`

### getControlY1

public final double getControlY1()
Gets the value of the `controlY1` property.

Property description:
  Defines the Y coordinate of the first control point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `controlY1` property
See Also:
  - `setControlY1(double)`
  - `controlY1Property()`

### controlY1Property

public final DoubleProperty controlY1Property()
Defines the Y coordinate of the first control point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `controlY1` property
See Also:
  - `getControlY1()`
  - `setControlY1(double)`

### setControlX2

public final void setControlX2(double value)
Sets the value of the `controlX2` property.

Property description:
  Defines the X coordinate of the second control point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `controlX2` property
See Also:
  - `getControlX2()`
  - `controlX2Property()`

### getControlX2

public final double getControlX2()
Gets the value of the `controlX2` property.

Property description:
  Defines the X coordinate of the second control point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `controlX2` property
See Also:
  - `setControlX2(double)`
  - `controlX2Property()`

### controlX2Property

public final DoubleProperty controlX2Property()
Defines the X coordinate of the second control point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `controlX2` property
See Also:
  - `getControlX2()`
  - `setControlX2(double)`

### setControlY2

public final void setControlY2(double value)
Sets the value of the `controlY2` property.

Property description:
  Defines the Y coordinate of the second control point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `controlY2` property
See Also:
  - `getControlY2()`
  - `controlY2Property()`

### getControlY2

public final double getControlY2()
Gets the value of the `controlY2` property.

Property description:
  Defines the Y coordinate of the second control point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `controlY2` property
See Also:
  - `setControlY2(double)`
  - `controlY2Property()`

### controlY2Property

public final DoubleProperty controlY2Property()
Defines the Y coordinate of the second control point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `controlY2` property
See Also:
  - `getControlY2()`
  - `setControlY2(double)`

### setEndX

public final void setEndX(double value)
Sets the value of the `endX` property.

Property description:
  Defines the X coordinate of the end point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `endX` property
See Also:
  - `getEndX()`
  - `endXProperty()`

### getEndX

public final double getEndX()
Gets the value of the `endX` property.

Property description:
  Defines the X coordinate of the end point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `endX` property
See Also:
  - `setEndX(double)`
  - `endXProperty()`

### endXProperty

public final DoubleProperty endXProperty()
Defines the X coordinate of the end point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `endX` property
See Also:
  - `getEndX()`
  - `setEndX(double)`

### setEndY

public final void setEndY(double value)
Sets the value of the `endY` property.

Property description:
  Defines the Y coordinate of the end point of the cubic curve segment.
Default value:
  0.0
Parameters:
  `value` - the value for the `endY` property
See Also:
  - `getEndY()`
  - `endYProperty()`

### getEndY

public final double getEndY()
Gets the value of the `endY` property.

Property description:
  Defines the Y coordinate of the end point of the cubic curve segment.
Default value:
  0.0
Returns:
  the value of the `endY` property
See Also:
  - `setEndY(double)`
  - `endYProperty()`

### endYProperty

public final DoubleProperty endYProperty()
Defines the Y coordinate of the end point of the cubic curve segment.

Default value:
  0.0
Returns:
  the `endY` property
See Also:
  - `getEndY()`
  - `setEndY(double)`

### toString

public String toString()
Returns a string representation of this `CubicCurve` object.

Overrides:
  `toString` in class `Node`
Returns:
  a string representation of this `CubicCurve` object.